unit Unit0051;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    FontDialog1: TFontDialog;
    Button2: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure G_CLS(C:TCanvas;x1,y1,x2,y2:Integer) ;
    procedure G_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
    procedure G_CIRC(C:TCanvas;rx1,ry1,rr1:Integer);
    function KLength(S:String): Integer ;
    function Get1Char(S:String;V1:Integer): String ;
    procedure CharDraw(x,y,mh,mw,ma:Double;s:String) ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ʂNA
procedure TForm1.G_CLS(C:TCanvas;x1,y1,x2,y2:Integer) ;
begin
   with C do begin
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(x1,y1,x2,y2);
   end;
end;

// `
procedure TForm1.G_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
begin
   with C do begin
      Pen.Mode := pmCopy ;
      Pen.Color := clBlue ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      MoveTo(rx1,ry1);
      LineTo(rx2,ry2);
   end;
end;

// ԁ`
procedure TForm1.G_CIRC(C:TCanvas;rx1,ry1,rr1:Integer);
begin
   with C do begin
      Pen.Mode := pmCopy ;
      Pen.Color := clRed ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      Brush.Color := clRed ;
      Brush.Style := bsSolid ;
      Ellipse(rx1-rr1,ry1-rr1,rx1+rr1,ry1+rr1);
   end;
end;

// ̒ijԂ@oCgł͂Ȃ
function TForm1.KLength(S:String): Integer ;
var
   i,j,i1:Integer ;
begin
   j := 0 ;
   i := 1 ;
   i1 := Length(S) ;
   while(i <= i1) do begin
      if (Ord(S[i]) >= 128)and(Ord(S[i]) <= 159)
       or(Ord(S[i]) >= 224)and(Ord(S[i]) <= 253) then
         Inc(i);
      Inc(i);
      Inc(j);
   end;
   Result := j ;
end;

// Po
//    V1 : ڂHi1`j
function TForm1.Get1Char(S:String;V1:Integer): String ;
var
   ss : String ;
   i,j,i1:Integer ;
   f : Boolean ;
begin
   ss := '';
   j := 0 ;
   i := 1 ;
   i1 := Length(S) ;
   f := True ;
   while(f) do begin
      ss := S[i];
      if (Ord(S[i]) >= 128)and(Ord(S[i]) <= 159)
       or(Ord(S[i]) >= 224)and(Ord(S[i]) <= 253) then begin
         Inc(i);
         ss := ss + S[i] ;
      end;
      Inc(i);
      Inc(j);
      if (j = V1) then f := False else ss:='';
      if (i > i1) then f := False;
   end;
   Result := ss ;
end;



// tHg
procedure TForm1.Button1Click(Sender: TObject);
begin
   FontDialog1.Execute ;
end;

// `
procedure TForm1.Button2Click(Sender: TObject);
var
   s,ss : String ;
   cx,cy : Integer ;
   mh,mw,ms,ma : double ;
   i : integer ;
   l : Double ;   // S
   dx,dy,x,y,ls : Double ;
   ix,iy : Integer ;
begin
   Image1.Picture := nil ;
   G_CLS(Image1.Canvas,0,0,Image1.Width,Image1.Height) ; // ʃNA
   cx := Image1.Width  div 2 ;
   cy := Image1.Height div 2 ;
   G_CIRC(Image1.Canvas,cx,cy,5);   // ɐԊۂ`

   s := Edit1.Text ;
   if (s = '') then exit ;
   val(Edit2.Text,mh,i);   if (i <> 0) then exit ;
   val(Edit3.Text,mw,i);   if (i <> 0) then exit ;
   val(Edit4.Text,ms,i);   if (i <> 0) then exit ;
   val(Edit5.Text,ma,i);   if (i <> 0) then exit ;
   if (mh <= 0.0)or(mw <= 0.0) then exit ;   // e̓`FbN

   l := Length(s)*mw/2.0 + (KLength(s)-1)*ms ;

   ix := cx + Round(l*Cos(ma*Pi/180.0));
   iy := cy - Round(l*Sin(ma*Pi/180.0));
   G_LINE(Image1.Canvas,cx,cy,ix,iy);  // S`Ă݂

   // _̒
   dx:= 0.0 ;
   dy:= 0.0 ;
   Case (RadioGroup1.ItemIndex)of
   { 0 :  0,0 }
   1: begin // 
         dx := 0.0 ;
         dy := mh/2.0 ;
      end;
   2: begin // 
         dx := 0.0 ;
         dy := mh ;
      end;
   3: begin // 
         dx := -l/2.0 ;
         dy := 0.0 ;
      end;
   4: begin // 
         dx := -l/2.0 ;
         dy := mh/2.0 ;
      end;
   5: begin // 
         dx := -l/2.0 ;
         dy := mh ;
      end;
   6: begin // E
         dx := -l ;
         dy := 0.0 ;
      end;
   7: begin // E
         dx := -l ;
         dy := mh/2.0 ;
      end;
   8: begin // E
         dx := -l ;
         dy := mh ;
      end;
   end;
   x := dx*Cos(ma*Pi/180.0)-dy*Sin(ma*Pi/180.0) ;
   y := dx*Sin(ma*Pi/180.0)+dy*Cos(ma*Pi/180.0) ;

   // }
   for i:=1 to KLength(s) do begin
      ss := Get1Char(s,i);
      CharDraw(x,y,mh,mw,ma,ss) ;
      ls:= Length(ss)*mw/2.0 + ms ;
      x := x + ls*Cos(ma*Pi/180.0);
      y := y + ls*Sin(ma*Pi/180.0);
   end;
end;

// P`
procedure TForm1.CharDraw(x,y,mh,mw,ma:Double;s:String) ;
var
   LogFont : TLogFont ;
   ih,iw,ia , ib,ii,iu,it,ic,ix,iy : Integer ;
   fo : String ;
begin
   ih := Round(mh) ;
   iw := Round(mw/ 2.0) ;  // p
   ia := Round(ma*10.0) ;

   ib := FW_NORMAL ;
   if (fsBold in FontDialog1.Font.Style) then ib := FW_BOLD ;
   ii := 0 ;
   if (fsItalic in FontDialog1.Font.Style) then ii := 1 ;
   iu := 0 ;
   if (fsUnderline in FontDialog1.Font.Style) then iu := 1 ;
   it := 0 ;
   if (fsStrikeOut in FontDialog1.Font.Style) then it := 1 ;
   fo := FontDialog1.Font.Name ;
   ic := FontDialog1.Font.Color ;

   ix := Image1.Width  div 2 + Round(x) ;
   iy := Image1.Height div 2 - Round(y) ;

   with LogFont do begin
      lfHeight := ih ;        // 
      lfWidth  := iw ;        // 
      lfEscapement := ia ;    // ]px[] 10{l
      lfOrientation := ia ;   // lfEscapementƓl
      lfWeight := ib ;        // w ʏ FW_NORMAL
      lfItalic := ii ;        // Α̎w L=1 =0
      lfUnderline := iu ;     // w L=1 =0
      lfStrikeOut := it ;     // w L=1 =0
      lfCharSet := DEFAULT_CHARSET ;
      lfOutPrecision := OUT_DEFAULT_PRECIS ;
      lfClipPrecision := CLIP_DEFAULT_PRECIS ;
      lfQuality := DEFAULT_QUALITY ;
      lfPitchAndFamily := DEFAULT_PITCH ;
      StrPCopy(lfFaceName,fo);   // tHg
   end;
   with Image1.Canvas do begin
      Font.Handle := CreateFontIndirect(LogFont);
      Font.Color := ic ;
      Brush.Style := bsClear ;
      TextOut(ix,iy,s);
   end;
end;

end.
